#!/usr/bin/env node
import t from "chalk";
import { execSync as m } from "node:child_process";
import l, { resolve as b } from "node:path";
import p, { existsSync as N, rmSync as f } from "node:fs";
import a from "prompts";
import { getConfigPath as P, batchHandler as S } from "@done-coding/cli-template";
import { lookForParentTarget as F } from "@done-coding/node-tools";
import I from "yargs";
import { hideBin as L } from "yargs/helpers";
const O = "git@gitee.com:justsosu/done-coding-cli-config-json.git", C = "自定义模版路径", U = "./.create-done-coding_temp", u = {
  version: "0.6.0",
  name: "create-done-coding",
  description: "项目创建命令行工具",
  cliConfig: {
    namespaceDir: ".done-coding",
    moduleName: "create"
  }
};
let w;
const _ = async () => (w || (w = (await A()).templateList), w), $ = async () => [...await _(), { name: C }], j = {
  type: "text",
  name: "projectName",
  message: "请输入项目名称",
  validate: (e) => e.trim().length > 0 || "项目名称不能为空"
}, G = async () => ({
  type: "select",
  name: "template",
  message: "请选择模板",
  choices: (await $()).map((s) => ({
    title: s.name,
    value: s.name
  }))
}), H = {
  type: "confirm",
  name: "saveGitHistory",
  message: "是否保留git历史",
  initial: !1
}, R = (e = "项目已存在，是否删除") => ({
  type: "confirm",
  name: "isRemove",
  message: e
}), A = async () => {
  console.log(t.blue("拉取模板列表，请稍等..."));
  const e = l.resolve(
    process.cwd(),
    U
  );
  if (console.log(t.blue(`配置临时目录：${e}`)), p.existsSync(e)) {
    const o = `${e}目录已存在，是否删除？`, { isRemove: r } = await a(R(o));
    r ? p.rmSync(e, { recursive: !0, force: !0 }) : (console.log(t.red(`${e}已存在，请手动删除后再试！`)), process.exit(1));
  }
  m(`git clone ${O} ${e} --depth=1`);
  const s = u.name, c = l.resolve(e, `${s}.json`), d = JSON.parse(p.readFileSync(c, "utf-8"));
  if (!Array.isArray(d.templateList))
    throw new Error("远程配置文件出错，templateList 不是数组");
  return console.log(t.green("模板列表拉取成功！")), p.rmSync(e, { recursive: !0, force: !0 }), d;
}, T = async (e) => {
  const { projectName: s, template: c } = e, o = ((s ?? (await a(j)).projectName) || "").trim();
  if (!o.trim()) {
    console.log(t.red("项目名称不能为空"));
    return;
  }
  if (o.includes(" ") || o.includes("\\") || o.includes("/")) {
    console.log(t.red("项目名称不能包含空格或者\\或者/"));
    return;
  }
  const r = b(process.cwd(), o);
  if (N(r)) {
    const { isRemove: i } = await a(R());
    if (i === !0)
      f(r, { recursive: !0, force: !0 });
    else
      return console.log(t.red("项目已存在")), process.exit(1);
  }
  const g = c ?? (await a(await G())).template;
  let v = "";
  if (g === C) {
    const { customUrl: i } = await a({
      type: "text",
      name: "customUrl",
      message: "请输入自定义模板路径"
    });
    v = i;
  } else {
    const i = (await $()).find(
      (n) => n.name === g
    );
    if (!i)
      return console.log(t.red(`模板${g}不存在`)), process.exit(1);
    if (!i.url)
      return console.log(t.red(`模板${g}仓库地址不存在`)), process.exit(1);
    v = i.url;
  }
  const y = F(".git");
  console.log(t.green("正在初始化项目，请稍等...")), m(`git clone ${v} ${o} --depth=1`);
  const h = P(r);
  if (h) {
    await S({
      rootDir: r,
      extraEnvData: {
        $projectName: o
      }
    });
    const { isRemoveTemplateConfig: i } = await a({
      type: "confirm",
      name: "isRemoveTemplateConfig",
      message: `已成功将模板项目配置注入到当前项目，是否删除模板项目配置文件(${h})`,
      initial: !0
    });
    i && f(h, { force: !0 });
  }
  if (console.log(t.green("项目初始化完成")), y) {
    const i = l.resolve(r), n = l.resolve(i, ".git");
    if (!N(n))
      throw new Error("git目录不存在");
    const { isRemoveGit: E } = await a({
      type: "confirm",
      name: "isRemoveGit",
      message: `项目创建在父级git仓库${y}中，是否删除${o}目录下的.git(${n})`,
      initial: !0
    });
    E ? (f(n, { recursive: !0, force: !0 }), console.log(t.green("已删除当前项目git目录"))) : console.log(
      t.yellow(
        `项目创建在父级git仓库${y}中，请手动删除${o}目录下的.git(${n})，否则会影响后续的git操作`
      )
    );
  } else {
    if ((await a(H)).saveGitHistory)
      m(
        `cd ${r} && git remote rename origin upstream && git fetch --unshallow`
      ), console.log(
        t.green(
          "已经将origin重命名为upstream，后续可以与模板git仓库有完整的交互"
        )
      ), console.log(
        t.green("已保存git历史记录，后续可以与模板git仓库有完整的交互")
      );
    else {
      const n = l.resolve(r, ".git");
      f(n, { recursive: !0, force: !0 }), m(`cd ${r} && git init`);
    }
    m(
      `cd ${r} && git add . && git commit -m '初始化${o}'`
    );
  }
  console.log(
    t.blue(`
使用步骤: 
  1. cd ${o}
  2. pnpm install
  3. pnpm run dev
  `)
  );
}, M = async () => ({
  projectName: {
    type: "string",
    alias: "p",
    describe: j.message
  },
  template: {
    type: "string",
    alias: "t",
    choices: (await $()).map((e) => e.name),
    describe: (await G()).message
  }
}), x = u.cliConfig.moduleName, k = (e, s) => {
  console.log(e ? t.red(e) : t.red(s.message)), process.exit(1);
}, Y = u.description, B = `Usage: $0 ${x} [options]`, J = "Usage: $0 [options]", D = async (e, s) => {
  const c = await M();
  return e.strict().usage(s).help("help").version(u.version).alias("v", "version").alias("h", "help").options(c).fail(k).argv;
}, q = (e) => D(e, B), oe = {
  command: x,
  describe: Y,
  builder: q,
  handler: T
}, se = async () => {
  const e = I(L(process.argv)), s = await D(e, J);
  return T(s);
};
export {
  oe as a,
  se as c,
  T as h
};
